Index: issm/trunk/src/c/modules/ModelProcessorx/ElementsAndVerticesPartitioning.cpp
===================================================================
--- issm/trunk/src/c/modules/ModelProcessorx/ElementsAndVerticesPartitioning.cpp	(revision 25994)
+++ issm/trunk/src/c/modules/ModelProcessorx/ElementsAndVerticesPartitioning.cpp	(revision 26744)
@@ -111,9 +111,14 @@
 
 	/*Start figuring out, out of the partition, which elements belong to this cpu: */
+	bool check = false;
 	for(int i=0;i<iomodel->numberofelements;i++){
 
 		/*!All elements have been partitioned above, only deal with elements for this cpu: */
-		if(my_rank==epart[i]) my_elements[i]=true;
+		if(my_rank==epart[i]){
+			my_elements[i]=true;
+			check = true;
+		}
 	}
+	if(!check) _error_("partition "<<my_rank<<" does not have any element! Try reducing md.cluster.np");
 
 	/*Assign pointers to iomodel*/
Index: issm/trunk/src/c/modules/ModelProcessorx/ModelProcessorx.cpp
===================================================================
--- issm/trunk/src/c/modules/ModelProcessorx/ModelProcessorx.cpp	(revision 25994)
+++ issm/trunk/src/c/modules/ModelProcessorx/ModelProcessorx.cpp	(revision 26744)
@@ -36,5 +36,5 @@
 
 	/*Partition Elements and Nodes*/
-	ElementsAndVerticesPartitioning(iomodel);
+	if (iomodel->numberofelements > 0) ElementsAndVerticesPartitioning(iomodel);
 
 	/*Create elements, vertices and materials, independent of analysis_enum: */
Index: issm/trunk/src/c/modules/OceanExchangeDatax/OceanExchangeDatax.cpp
===================================================================
--- issm/trunk/src/c/modules/OceanExchangeDatax/OceanExchangeDatax.cpp	(revision 25994)
+++ issm/trunk/src/c/modules/OceanExchangeDatax/OceanExchangeDatax.cpp	(revision 26744)
@@ -60,8 +60,8 @@
 		femmodel->parameters->SetParam(oceangridnxsize,OceanGridNxEnum);
 		femmodel->parameters->SetParam(oceangridnysize,OceanGridNyEnum);
+		oceangridx=xNew<IssmDouble>(ngrids_ocean);
+		oceangridy=xNew<IssmDouble>(ngrids_ocean);
 		if(my_rank==0){
-			oceangridx = xNew<IssmDouble>(ngrids_ocean);
 			ISSM_MPI_Recv(oceangridx,ngrids_ocean,ISSM_MPI_DOUBLE,0,10001005,tomitgcmcomm,&status);
-			oceangridy = xNew<IssmDouble>(ngrids_ocean);
 			ISSM_MPI_Recv(oceangridy,ngrids_ocean,ISSM_MPI_DOUBLE,0,10001006,tomitgcmcomm,&status);
 
@@ -70,8 +70,5 @@
 			ISSM_MPI_Recv(&oceantime,1,ISSM_MPI_DOUBLE,0,10001002,tomitgcmcomm,&status);
 		}
-		if(my_rank!=0){
-			oceangridx=xNew<IssmDouble>(ngrids_ocean);
-			oceangridy=xNew<IssmDouble>(ngrids_ocean);
-		}
+		
 		ISSM_MPI_Bcast(oceangridx,ngrids_ocean,ISSM_MPI_DOUBLE,0,IssmComm::GetComm());
 		ISSM_MPI_Bcast(oceangridy,ngrids_ocean,ISSM_MPI_DOUBLE,0,IssmComm::GetComm());
Index: issm/trunk/src/c/modules/RheologyBbarAbsGradientx/RheologyBbarAbsGradientx.cpp
===================================================================
--- issm/trunk/src/c/modules/RheologyBbarAbsGradientx/RheologyBbarAbsGradientx.cpp	(revision 25994)
+++ issm/trunk/src/c/modules/RheologyBbarAbsGradientx/RheologyBbarAbsGradientx.cpp	(revision 26744)
@@ -79,5 +79,5 @@
 
 	/*clean up and Return: */
-	if(domaintype!=Domain2DhorizontalEnum){basalelement->DeleteMaterials(); delete basalelement;};
+	if(basalelement->IsSpawnedElement()){basalelement->DeleteMaterials(); delete basalelement;};
 	xDelete<IssmDouble>(xyz_list);
 	delete gauss;
Index: issm/trunk/src/c/modules/SetActiveNodesLSMx/SetActiveNodesLSMx.cpp
===================================================================
--- issm/trunk/src/c/modules/SetActiveNodesLSMx/SetActiveNodesLSMx.cpp	(revision 25994)
+++ issm/trunk/src/c/modules/SetActiveNodesLSMx/SetActiveNodesLSMx.cpp	(revision 26744)
@@ -63,5 +63,7 @@
 	int numvertices=femmodel->vertices->NumberOfVertices();
 	if(numvertices==0)  return;
-	Vector<IssmDouble>* vec_mask_ice=new Vector<IssmDouble>(numvertices);
+
+	int numvert_local = femmodel->vertices->NumberOfVerticesLocal();
+	Vector<IssmDouble>* vec_mask_ice=new Vector<IssmDouble>(numvert_local,numvertices);
 
 	/*Fill vector with values: */
@@ -71,5 +73,5 @@
 			int nbv = element->GetNumberOfVertices();
 			for(int iv=0;iv<nbv;iv++){
-				vec_mask_ice->SetValue(element->vertices[iv]->Sid(),1.,INS_VAL);
+				vec_mask_ice->SetValue(element->vertices[iv]->Pid(),1.,INS_VAL);
 			}
 		}
@@ -78,5 +80,5 @@
 	/*Assemble vector and serialize */
 	vec_mask_ice->Assemble();
-	InputUpdateFromVectorx(femmodel,vec_mask_ice,IceMaskNodeActivationEnum,VertexSIdEnum);
+	InputUpdateFromVectorx(femmodel,vec_mask_ice,IceMaskNodeActivationEnum,VertexPIdEnum);
 	delete vec_mask_ice;
 }/*}}}*/
Index: issm/trunk/src/c/modules/StochasticForcingx/StochasticForcingx.cpp
===================================================================
--- issm/trunk/src/c/modules/StochasticForcingx/StochasticForcingx.cpp	(revision 26744)
+++ issm/trunk/src/c/modules/StochasticForcingx/StochasticForcingx.cpp	(revision 26744)
@@ -0,0 +1,203 @@
+/*!\file StochasticForcingx
+ * \brief: compute noise terms for the StochasticForcing fields
+ */
+
+#include "./StochasticForcingx.h"
+#include "../../classes/Loads/Friction.h"
+#include "../../shared/shared.h"
+#include "../../toolkits/toolkits.h"
+#include "../../shared/Random/random.h"
+
+void StochasticForcingx(FemModel* femmodel){/*{{{*/
+
+
+	//VV testing (12Nov)
+	/*
+	IssmDouble timeVV,dtVV,starttimeVV;
+	femmodel->parameters->FindParam(&timeVV,TimeEnum);
+   femmodel->parameters->FindParam(&dtVV,TimesteppingTimeStepEnum);
+   femmodel->parameters->FindParam(&starttimeVV,TimesteppingStartTimeEnum);
+	IssmDouble valMean = 0;
+	IssmDouble valSdev = 0.5;
+	int seed;
+	//seed = reCast<int,IssmDouble>((timeVV-starttimeVV)/dtVV);
+	seed = -1;
+	IssmDouble rdmVV;
+	univariateNormal_test0(&rdmVV,valMean,valSdev,seed);
+	_printf_("VV rdmVV: "<<rdmVV<<'\n');
+	*/
+
+   /*Retrieve parameters*/
+   bool randomflag;
+   int M,N,numfields,my_rank;
+   int* fields            = NULL;
+   int* dimensions        = NULL;
+   IssmDouble* covariance = NULL;
+   femmodel->parameters->FindParam(&randomflag,StochasticForcingRandomflagEnum);
+   femmodel->parameters->FindParam(&numfields,StochasticForcingNumFieldsEnum);
+   femmodel->parameters->FindParam(&fields,&N,StochasticForcingFieldsEnum);    _assert_(N==numfields);
+   femmodel->parameters->FindParam(&dimensions,&N,StochasticForcingDimensionsEnum);    _assert_(N==numfields);
+   int dimtot=0;
+   for(int i=0;i<numfields;i++) dimtot = dimtot+dimensions[i];
+   femmodel->parameters->FindParam(&covariance,&M,&N,StochasticForcingCovarianceEnum); _assert_(M==dimtot); _assert_(N==dimtot);
+
+   /*Compute noise terms*/
+   IssmDouble* noiseterms = xNew<IssmDouble>(dimtot);
+   my_rank=IssmComm::GetRank();
+   if(my_rank==0){
+      int fixedseed;
+      IssmDouble time,dt,starttime;
+      femmodel->parameters->FindParam(&time,TimeEnum);
+      femmodel->parameters->FindParam(&dt,TimesteppingTimeStepEnum);
+      femmodel->parameters->FindParam(&starttime,TimesteppingStartTimeEnum);
+		/*Determine whether random seed is fixed to time step (randomflag==false) or random seed truly random (randomflag==true)*/
+      if(randomflag) fixedseed=-1;
+      else fixedseed = reCast<int,IssmDouble>((time-starttime)/dt);
+		/*multivariateNormal needs to be passed a NULL pointer to avoid memory leak issues*/
+      IssmDouble* temparray = NULL;
+      multivariateNormal(&temparray,dimtot,0.0,covariance,fixedseed);
+      for(int i=0;i<dimtot;i++) noiseterms[i]=temparray[i];
+      xDelete<IssmDouble>(temparray);
+   }
+   ISSM_MPI_Bcast(noiseterms,dimtot,ISSM_MPI_DOUBLE,0,IssmComm::GetComm());
+   
+	int i=0;
+   for(int j=0;j<numfields;j++){
+      int dimenum_type,noiseenum_type;
+      IssmDouble* noisefield = xNew<IssmDouble>(dimensions[j]);
+      for(int k=0;k<dimensions[j];k++){
+         noisefield[k]=noiseterms[i+k];
+      }
+     
+		int dimensionid;
+
+		/*Deal with the autoregressive models*/
+		if(fields[j]==SMBautoregressionEnum || fields[j]==FrontalForcingsRignotAutoregressionEnum){
+			switch(fields[j]){
+				case SMBautoregressionEnum:
+					dimenum_type   = SmbBasinsIdEnum;
+					noiseenum_type = SmbAutoregressionNoiseEnum;
+					break;
+				case FrontalForcingsRignotAutoregressionEnum:
+					dimenum_type   = FrontalForcingsBasinIdEnum;
+					noiseenum_type = ThermalforcingAutoregressionNoiseEnum;
+					break;
+			}
+			for(Object* &object:femmodel->elements->objects){
+            Element* element = xDynamicCast<Element*>(object);
+            int numvertices  = element->GetNumberOfVertices();
+            IssmDouble* noise_element = xNew<IssmDouble>(numvertices);
+            element->GetInputValue(&dimensionid,dimenum_type);
+            for(int i=0;i<numvertices;i++) noise_element[i] = noisefield[dimensionid];
+            element->AddInput(noiseenum_type,noise_element,P0Enum);
+            xDelete<IssmDouble>(noise_element);
+			}
+		}
+		else{
+			switch(fields[j]){
+				case SMBautoregressionEnum:
+				case FrontalForcingsRignotAutoregressionEnum:
+					/*Already done above*/
+					break;
+				case DefaultCalvingEnum:
+					/*Delete CalvingCalvingrateEnum at previous time step (required if it is transient)*/
+					femmodel->inputs->DeleteInput(CalvingCalvingrateEnum);
+					for(Object* &object:femmodel->elements->objects){
+						Element* element = xDynamicCast<Element*>(object);
+						int numvertices  = element->GetNumberOfVertices();
+						IssmDouble baselinecalvingrate;
+						IssmDouble calvingrate_tot[numvertices];
+						Input* baselinecalvingrate_input  = NULL;
+						baselinecalvingrate_input = element->GetInput(BaselineCalvingCalvingrateEnum); _assert_(baselinecalvingrate_input);
+						element->GetInputValue(&dimensionid,StochasticForcingDefaultIdEnum);
+						Gauss* gauss = element->NewGauss();
+						for(int i=0;i<numvertices;i++){
+							gauss->GaussVertex(i);
+							baselinecalvingrate_input->GetInputValue(&baselinecalvingrate,gauss);
+							calvingrate_tot[i] = max(0.0,baselinecalvingrate+noisefield[dimensionid]);
+						}
+						element->AddInput(CalvingCalvingrateEnum,&calvingrate_tot[0],P1DGEnum);
+						delete gauss;
+					}
+					break;
+				case FloatingMeltRateEnum:
+					/*Delete BasalforcingsFloatingiceMeltingRateEnum at previous time step (required if it is transient)*/
+					femmodel->inputs->DeleteInput(BasalforcingsFloatingiceMeltingRateEnum);
+					for(Object* &object:femmodel->elements->objects){
+						Element* element = xDynamicCast<Element*>(object);
+						int numvertices  = element->GetNumberOfVertices();
+						IssmDouble baselinefloatingicemeltrate;
+						IssmDouble floatingicemeltrate_tot[numvertices];
+						Input* baselinefloatingicemeltrate_input  = NULL;
+						baselinefloatingicemeltrate_input = element->GetInput(BaselineBasalforcingsFloatingiceMeltingRateEnum); _assert_(baselinefloatingicemeltrate_input);
+						element->GetInputValue(&dimensionid,StochasticForcingDefaultIdEnum);
+						Gauss* gauss = element->NewGauss();
+						for(int i=0;i<numvertices;i++){
+							gauss->GaussVertex(i);
+							baselinefloatingicemeltrate_input->GetInputValue(&baselinefloatingicemeltrate,gauss);
+							floatingicemeltrate_tot[i] = max(0.0,baselinefloatingicemeltrate+noisefield[dimensionid]);
+						}
+						element->AddInput(BasalforcingsFloatingiceMeltingRateEnum,&floatingicemeltrate_tot[0],P1DGEnum);
+						delete gauss;
+					}
+					break;
+				//VV working(29Nov2021)
+				case FrictionWaterPressureEnum:
+					/*Specify that WaterPressure is stochastic*/ 
+					femmodel->parameters->SetParam(true,StochasticForcingIsWaterPressureEnum);
+					for(Object* &object:femmodel->elements->objects){
+                  Element* element = xDynamicCast<Element*>(object);
+                  int numvertices  = element->GetNumberOfVertices();
+                  IssmDouble p_water_deterministic[numvertices];
+                  IssmDouble p_water[numvertices];
+						element->GetInputValue(&dimensionid,StochasticForcingDefaultIdEnum);
+						Gauss* gauss=element->NewGauss();
+						Friction* friction = new Friction(element);
+						for(int i=0;i<numvertices;i++){
+							gauss->GaussVertex(i);
+							p_water_deterministic[i] = friction->SubglacialWaterPressure(gauss);
+							p_water[i]               = p_water_deterministic[i] + noisefield[dimensionid]; //make sure positive (29Nov2021)
+							p_water[i]               = max(0.0,p_water[i]);
+						}
+						element->AddInput(FrictionWaterPressureEnum,p_water,P1DGEnum);
+						delete gauss;
+						delete friction;
+					}
+					break;
+
+				/*
+				case FrictionEffectivePressureEnum:
+					femmodel->parameters->SetParam(true,StochasticForcingIsEffectivePressureEnum);
+					for(Object* &object:femmodel->elements->objects){
+                  Element* element = xDynamicCast<Element*>(object);
+                  int numvertices  = element->GetNumberOfVertices();
+                  IssmDouble Neff[numvertices];
+						element->GetInputValue(&dimensionid,StochasticForcingDefaultIdEnum);
+						Gauss* gauss=element->NewGauss();
+						Friction* friction = new Friction(element);
+						for(int i=0;i<numvertices;i++){
+							gauss->GaussVertex(i);
+							Neff[i] = friction->EffectivePressure(gauss);
+							Neff[i] = Neff[i]+noisefield[dimensionid];
+						}
+						element->AddInput(FrictionEffectivePressureEnum,Neff,P1DGEnum);
+						delete gauss;
+						delete friction;
+					}
+					break;
+				*/
+
+				default:
+					_error_("Field "<<EnumToStringx(fields[j])<<" does not support stochasticity yet.");
+			}
+		}
+		i=i+dimensions[j];
+      xDelete<IssmDouble>(noisefield);
+   }
+
+	/*Cleanup*/
+   xDelete<int>(fields);
+   xDelete<int>(dimensions);
+   xDelete<IssmDouble>(covariance);
+   xDelete<IssmDouble>(noiseterms);
+}/*}}}*/
Index: issm/trunk/src/c/modules/StochasticForcingx/StochasticForcingx.h
===================================================================
--- issm/trunk/src/c/modules/StochasticForcingx/StochasticForcingx.h	(revision 26744)
+++ issm/trunk/src/c/modules/StochasticForcingx/StochasticForcingx.h	(revision 26744)
@@ -0,0 +1,10 @@
+#ifndef _STOCHASTICFORCINGX_H
+#define _STOCHASTICFORCINGX_H
+
+#include "../../classes/classes.h"
+#include "../../analyses/analyses.h"
+
+/* local prototypes: */
+void StochasticForcingx(FemModel* femmodel);
+
+#endif
Index: issm/trunk/src/c/modules/SurfaceAbsVelMisfitx/SurfaceAbsVelMisfitx.cpp
===================================================================
--- issm/trunk/src/c/modules/SurfaceAbsVelMisfitx/SurfaceAbsVelMisfitx.cpp	(revision 25994)
+++ issm/trunk/src/c/modules/SurfaceAbsVelMisfitx/SurfaceAbsVelMisfitx.cpp	(revision 26744)
@@ -61,11 +61,23 @@
 	/*Retrieve all inputs we will be needing: */
 	DatasetInput* weights_input=topelement->GetDatasetInput(InversionCostFunctionsCoefficientsEnum); _assert_(weights_input);
-	Input* vx_input     =topelement->GetInput(VxEnum);                                 _assert_(vx_input);
-	Input* vxobs_input  =topelement->GetInput(InversionVxObsEnum);                     _assert_(vxobs_input);
+	Input* vx_input     = NULL;
+	Input* vxobs_input  = topelement->GetInput(InversionVxObsEnum);	_assert_(vxobs_input);
 	Input* vy_input     = NULL;
 	Input* vyobs_input  = NULL;
-	if(numcomponents==2){
-		vy_input    =topelement->GetInput(VyEnum);              _assert_(vy_input);
-		vyobs_input =topelement->GetInput(InversionVyObsEnum);  _assert_(vyobs_input);
+
+	/*Read SurfaceEnum from 2D models:SSA, L1L2, MLHO*/
+	if (domaintype == Domain2DhorizontalEnum) {
+		vx_input = topelement->GetInput(VxSurfaceEnum);					_assert_(vx_input);
+		if(numcomponents==2){
+			vy_input    =topelement->GetInput(VySurfaceEnum);        _assert_(vy_input);
+			vyobs_input =topelement->GetInput(InversionVyObsEnum);	_assert_(vyobs_input);
+		}
+	}
+	else {
+		vx_input = topelement->GetInput(VxEnum);							_assert_(vx_input);
+		if(numcomponents==2){
+			vy_input    =topelement->GetInput(VyEnum);					_assert_(vy_input);
+			vyobs_input =topelement->GetInput(InversionVyObsEnum);	_assert_(vyobs_input);
+		}
 	}
 
@@ -101,5 +113,5 @@
 
 	/*clean up and Return: */
-	if(domaintype!=Domain2DhorizontalEnum){topelement->DeleteMaterials(); delete topelement;};
+	if(topelement->IsSpawnedElement()){topelement->DeleteMaterials(); delete topelement;};
 	xDelete<IssmDouble>(xyz_list);
 	delete gauss;
Index: issm/trunk/src/c/modules/SurfaceAverageVelMisfitx/SurfaceAverageVelMisfitx.cpp
===================================================================
--- issm/trunk/src/c/modules/SurfaceAverageVelMisfitx/SurfaceAverageVelMisfitx.cpp	(revision 25994)
+++ issm/trunk/src/c/modules/SurfaceAverageVelMisfitx/SurfaceAverageVelMisfitx.cpp	(revision 26744)
@@ -69,12 +69,24 @@
 	DatasetInput* weights_input=topelement->GetDatasetInput(InversionCostFunctionsCoefficientsEnum); _assert_(weights_input);
 	Input* S_input      = topelement->GetInput(SurfaceAreaEnum);     _assert_(S_input);
-	Input* vx_input     = topelement->GetInput(VxEnum);              _assert_(vx_input);
-	Input* vxobs_input  = topelement->GetInput(InversionVxObsEnum);  _assert_(vxobs_input);
-	Input* vy_input     = NULL;
-	Input* vyobs_input  = NULL;
-	if(numcomponents==2){
-		vy_input    =topelement->GetInput(VyEnum);              _assert_(vy_input);
-		vyobs_input =topelement->GetInput(InversionVyObsEnum);  _assert_(vyobs_input);
+   Input* vx_input     = NULL;
+   Input* vxobs_input  = topelement->GetInput(InversionVxObsEnum); _assert_(vxobs_input);
+   Input* vy_input     = NULL;
+   Input* vyobs_input  = NULL;
+
+   /*Read SurfaceEnum from 2D models:SSA, L1L2, MLHO*/
+   if (domaintype == Domain2DhorizontalEnum) {
+      vx_input = topelement->GetInput(VxSurfaceEnum);             _assert_(vx_input);
+      if(numcomponents==2){
+         vy_input    =topelement->GetInput(VySurfaceEnum);        _assert_(vy_input);
+         vyobs_input =topelement->GetInput(InversionVyObsEnum);   _assert_(vyobs_input);
+      }
 	}
+   else {
+      vx_input = topelement->GetInput(VxEnum);                    _assert_(vx_input);
+      if(numcomponents==2){
+         vy_input    =topelement->GetInput(VyEnum);               _assert_(vy_input);
+         vyobs_input =topelement->GetInput(InversionVyObsEnum);   _assert_(vyobs_input);
+      }
+   }
 
 	/* Start  looping on the number of gaussian points: */
@@ -113,5 +125,5 @@
 
 	/*clean up and Return: */
-	if(domaintype!=Domain2DhorizontalEnum){topelement->DeleteMaterials(); delete topelement;};
+	if(topelement->IsSpawnedElement()){topelement->DeleteMaterials(); delete topelement;};
 	xDelete<IssmDouble>(xyz_list);
 	delete gauss;
Index: issm/trunk/src/c/modules/SurfaceLogVelMisfitx/SurfaceLogVelMisfitx.cpp
===================================================================
--- issm/trunk/src/c/modules/SurfaceLogVelMisfitx/SurfaceLogVelMisfitx.cpp	(revision 25994)
+++ issm/trunk/src/c/modules/SurfaceLogVelMisfitx/SurfaceLogVelMisfitx.cpp	(revision 26744)
@@ -63,12 +63,24 @@
 	/*Retrieve all inputs we will be needing: */
 	DatasetInput* weights_input=topelement->GetDatasetInput(InversionCostFunctionsCoefficientsEnum); _assert_(weights_input);
-	Input* vx_input     =topelement->GetInput(VxEnum);                                 _assert_(vx_input);
-	Input* vxobs_input  =topelement->GetInput(InversionVxObsEnum);                     _assert_(vxobs_input);
-	Input* vy_input     = NULL;
-	Input* vyobs_input  = NULL;
-	if(numcomponents==2){
-		vy_input    =topelement->GetInput(VyEnum);              _assert_(vy_input);
-		vyobs_input =topelement->GetInput(InversionVyObsEnum);  _assert_(vyobs_input);
+   Input* vx_input     = NULL;
+   Input* vxobs_input  = topelement->GetInput(InversionVxObsEnum);   _assert_(vxobs_input);
+   Input* vy_input     = NULL;
+   Input* vyobs_input  = NULL;
+
+   /*Read SurfaceEnum from 2D models:SSA, L1L2, MLHO*/
+   if (domaintype == Domain2DhorizontalEnum) {
+      vx_input = topelement->GetInput(VxSurfaceEnum);             _assert_(vx_input);
+      if(numcomponents==2){
+         vy_input    =topelement->GetInput(VySurfaceEnum);        _assert_(vy_input);
+         vyobs_input =topelement->GetInput(InversionVyObsEnum);   _assert_(vyobs_input);
+      }
 	}
+   else {
+      vx_input = topelement->GetInput(VxEnum);                    _assert_(vx_input);
+      if(numcomponents==2){
+         vy_input    =topelement->GetInput(VyEnum);               _assert_(vy_input);
+         vyobs_input =topelement->GetInput(InversionVyObsEnum);   _assert_(vyobs_input);
+      }
+   }
 
 	/* Start  looping on the number of gaussian points: */
@@ -110,5 +122,5 @@
 
 	/*clean up and Return: */
-	if(domaintype!=Domain2DhorizontalEnum){topelement->DeleteMaterials(); delete topelement;};
+	if(topelement->IsSpawnedElement()){topelement->DeleteMaterials(); delete topelement;};
 	xDelete<IssmDouble>(xyz_list);
 	delete gauss;
Index: issm/trunk/src/c/modules/SurfaceLogVxVyMisfitx/SurfaceLogVxVyMisfitx.cpp
===================================================================
--- issm/trunk/src/c/modules/SurfaceLogVxVyMisfitx/SurfaceLogVxVyMisfitx.cpp	(revision 25994)
+++ issm/trunk/src/c/modules/SurfaceLogVxVyMisfitx/SurfaceLogVxVyMisfitx.cpp	(revision 26744)
@@ -63,12 +63,24 @@
 	/*Retrieve all inputs we will be needing: */
 	DatasetInput* weights_input=topelement->GetDatasetInput(InversionCostFunctionsCoefficientsEnum); _assert_(weights_input);
-	Input* vx_input     =topelement->GetInput(VxEnum);                                 _assert_(vx_input);
-	Input* vxobs_input  =topelement->GetInput(InversionVxObsEnum);                     _assert_(vxobs_input);
-	Input* vy_input     = NULL;
-	Input* vyobs_input  = NULL;
-	if(numcomponents==2){
-		vy_input    =topelement->GetInput(VyEnum);              _assert_(vy_input);
-		vyobs_input =topelement->GetInput(InversionVyObsEnum);  _assert_(vyobs_input);
+   Input* vx_input     = NULL;
+   Input* vxobs_input  = topelement->GetInput(InversionVxObsEnum);   _assert_(vxobs_input);
+   Input* vy_input     = NULL;
+   Input* vyobs_input  = NULL;
+
+   /*Read SurfaceEnum from 2D models:SSA, L1L2, MLHO*/
+   if (domaintype == Domain2DhorizontalEnum) {
+      vx_input = topelement->GetInput(VxSurfaceEnum);             _assert_(vx_input);
+      if(numcomponents==2){
+         vy_input    =topelement->GetInput(VySurfaceEnum);        _assert_(vy_input);
+         vyobs_input =topelement->GetInput(InversionVyObsEnum);   _assert_(vyobs_input);
+      }
 	}
+   else {
+      vx_input = topelement->GetInput(VxEnum);                    _assert_(vx_input);
+      if(numcomponents==2){
+         vy_input    =topelement->GetInput(VyEnum);               _assert_(vy_input);
+         vyobs_input =topelement->GetInput(InversionVyObsEnum);   _assert_(vyobs_input);
+      }
+   }
 
 	/* Start  looping on the number of gaussian points: */
@@ -110,5 +122,5 @@
 
 	/*clean up and Return: */
-	if(domaintype!=Domain2DhorizontalEnum){topelement->DeleteMaterials(); delete topelement;};
+	if(topelement->IsSpawnedElement()){topelement->DeleteMaterials(); delete topelement;};
 	xDelete<IssmDouble>(xyz_list);
 	delete gauss;
